<?php

namespace App\Nova\Resources\Legal;

use App\Models\Legal\LegalPage as LegalPageModel;
use App\Nova\Filters\VisableFilter;
use App\Nova\Forms\NovaForm;
use App\Nova\Resource;
use Illuminate\Http\Request;
use Laravel\Nova\Fields\Hidden;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\Slug;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Fields\Trix;
use Laravel\Nova\Http\Requests\NovaRequest;
use Trin4ik\NovaSwitcher\NovaSwitcher;

class LegalPage extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<LegalPageModel>
     */
    public static $model = LegalPageModel::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'title';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = [
        'slug', 'title',
    ];

    /**
     * Get the displayable label of the resource.
     */
    public static function label(): string
    {
        return __('Legal pages');
    }

    /**
     * Get the displayable singular label of the resource.
     */
    public static function singularLabel(): string
    {
        return __('Legal page');
    }

    /**
     * Get the fields displayed by the resource.
     */
    public function fields(NovaRequest $request): array
    {
        return [
            ID::make()->sortable(),

            Slug::make(__('Slug'), 'slug')
                ->hideWhenCreating(),

            Hidden::make('slug')
                ->fillUsing(NovaForm::fillSlug(['title', 'en'], LegalPageModel::class))
                ->hideWhenUpdating(),

            Text::make(__('Title'), 'title')
                ->rules('required')
                ->translatable(),

            Trix::make(__('Content'), 'content')
                ->rules('required')
                ->alwaysShow()
                ->translatable(),

            NovaSwitcher::make(__('Active'), 'is_active')
                ->default(true),
        ];
    }

    /**
     * Get the cards available for the request.
     */
    public function cards(NovaRequest $request): array
    {
        return [];
    }

    /**
     * Get the filters available for the resource.
     */
    public function filters(NovaRequest $request): array
    {
        return [
            VisableFilter::make(),
        ];
    }

    /**
     * Get the lenses available for the resource.
     */
    public function lenses(NovaRequest $request): array
    {
        return [];
    }

    /**
     * Get the actions available for the resource.
     */
    public function actions(NovaRequest $request): array
    {
        return [];
    }
}
